<!doctype html public "-//W3C//DTD HTML 4.0 //EN">
<html>
<head>
       <title>Vererbung und Dynamische Bindung/Polymorphismus</title>
</head>
<body>
<?php
require_once("1_ProduktVererbung.php");

// Warenkorb
class Warenkorb {
  // Array fr Produkte und Mengen
  private $produkte;
  // Konstruktor
  public function __construct(){
    $produkte = array();
  }
  // Produkt-Klon zurckliefern
  public function getProdukt($nr){
    return clone($this->produkte[$nr]["produkt"]);
  }
  // Produkt in Warenkorb aufnehmen, ndern oder lschen
  public function setProdukt(Produkt $produkt, $menge){
    $test = $this->getProdukt($produkt->getNr());
    // Kaufen
    if (empty($test)){
      $this->produkte[$produkt->getNr()]
        = array("produkt" => $produkt,
                "menge"   => $menge);
    }
    // Lschen
    elseif ($menge == 0){
      unset($this->produkte[$produkt->getNr()]);
    }
    // ndern
    else {
      $this->produkte[$produkt->getNr()]["menge"] = $menge;
    }        
  }
  // Gesamtpreis fr Produkte (CD oder Buch) errechnen
  public function getGesamtpreis(){
    $preis = 0;
    foreach ($this->produkte as $posten){
      $preis += $posten["produkt"]->getBruttoPreis()
                * $posten["menge"]; 
    }
    return $preis;
  }
  // Einfache bersicht fr Kontrollen
  public function getUebersicht(){
   echo "<pre>";
   print_r($this);
   echo "</pre>";   
  }    
}

// Produkte anlegen
$buch = new Buch(1, "PHP und Oracle", 32.66, 0.07, 300);
$cd = new  CD(2, "PHP - Songs of OOP", 12.59, 0.19, 55.32);
// Warenkorb testen
$warenkorb =  new Warenkorb;
$warenkorb->setProdukt($buch, 1);
$warenkorb->setProdukt($cd, 2);
echo "Preis mit einem Buch und zwei CDs: "
     .$warenkorb->getGesamtpreis()
     ."<br/>";
$warenkorb->getUebersicht();     
// Produkt ndern
$warenkorb->setProdukt($buch, 2);
$warenkorb->setProdukt($cd, 3);
echo "Preis mit zwei Bchern und drei CDs: "
     .$warenkorb->getGesamtpreis()
     ."<br/>";
// Produkt lschen
$warenkorb->setProdukt($buch, 0);
$warenkorb->getUebersicht();
?>
</body>
</html>
