<!doctype html public "-//W3C//DTD HTML 4.0 //EN">
<html>
<head>
       <title>Kapselung von Warenkorbprodukten</title>
</head>
<body>
<?php
require_once("1_ProduktVererbung.php");

// ProduktMenge
class WKProdukt {
   private $menge;
   private $produkt;
   
   public function __construct(Produkt $produkt, $menge){
      $this->setMenge($menge);
      $this->setProdukt($produkt);   
   }
   
   public function setMenge($menge){
    if (is_integer($menge) && $menge >= 0){       
      $this->menge = $menge;
    }   
   }
   public function getMenge(){
     return $this->menge;   
   }
   public function setProdukt(Produkt $produkt){
     $this->produkt = $produkt;
   }
   public function getProdukt(){
      return $this->produkt;   
   }               
}
// Warenkorb
class Warenkorb {
  // Array fr Produkte und Mengen
  private $produkte;
  // Konstruktor
  public function __construct(){
    $this->produkte = array();
  }
  // Produkt-Klon zurckliefern
  public function getProdukt($nr){
    return clone($this->produkte[$nr]);
  }
  // Produkt in Warenkorb aufnehmen, ndern oder lschen
  public function setProdukt(WKProdukt $produkt){
    $test = $this->getProdukt($produkt->getProdukt()->getNr());
    // Kaufen
    if (empty($test)){
      $this->produkte[$produkt->getProdukt()->getNr()] = $produkt;
    }
    // Lschen
    elseif ($produkt->getMenge() == 0){
      unset($this->produkte[$produkt->getProdukt()->getNr()]);
    }
    // ndern
    else {
      $this->produkte[$produkt->getProdukt()->getNr()] = $produkt;
    }        
  }
  // Gesamtpreis fr Produkte (CD oder Buch) errechnen
  public function getGesamtpreis(){
    $preis = 0;
    foreach ($this->produkte as $posten){
      $preis += $posten->getProdukt()->getBruttoPreis()
                * $posten->getMenge(); 
    }
    return $preis;
  }
  // Einfache bersicht fr Kontrollen
  public function getUebersicht(){
   echo "<pre>";
   print_r($this);
   echo "</pre>";   
  }    
}

// Produkte anlegen
$buch = new Buch(1, "PHP und Oracle", 32.66, 0.07, 300);
$cd = new  CD(2, "PHP - Songs of OOP", 12.59, 0.19, 55.32);
// Warenkorb testen
$warenkorb =  new Warenkorb;
$warenkorb->setProdukt(new WKProdukt($buch, 1));
$warenkorb->setProdukt(new WKProdukt($cd, 2));
echo "Preis mit einem Buch und zwei CDs: "
     .$warenkorb->getGesamtpreis()
     ."<br/>";
$warenkorb->getUebersicht();     
// Produkt ndern
$warenkorb->setProdukt(new WKProdukt($buch, 2));
$warenkorb->setProdukt(new WKProdukt($cd, 3));
echo "Preis mit zwei Bchern und drei CDs: "
     .$warenkorb->getGesamtpreis()
     ."<br/>";
// Produkt lschen
$warenkorb->setProdukt(new WKProdukt($buch, 0));
$warenkorb->getUebersicht();
?>
</body>
</html>
