<!doctype html public "-//W3C//DTD HTML 4.0 //EN">
<html>
<head>
       <title>Dynamische Bindung, Polymorphismus, berschreibung</title>
</head>
<body>
<?php
class Kunde {
  public $vorname;
  public $nachname;
  public $nr;
  
  public function __construct($nr, $vorname, $nachname){
    $this->vorname  = $vorname;
    $this->nachname = $nachname;
    $this->nr       = $nr;
  }
}

// Ausgabe-Elternklasse
class Ausgabe {
   protected $kunde;
   public function __construct(Kunde $kunde){
     $this->setKunde($kunde);       
   }
   public function setKunde(Kunde $kunde){
     $this->kunde = $kunde;       
   }
   public function getBeschreibung(){
     return "Nr: ".$this->kunde->nr." | Vorname: ".$this->kunde->vorname." | Nachname: ".$this->kunde->nachname;       
   }       
}
// Ausgabe XML
class XML extends Ausgabe {
   public function getBeschreibung(){
     return "<kunde><nr>".$this->kunde->nr."</nr><vorname>".$this->kunde->vorname."</vorname><nachname>".$this->kunde->nachname."</nachname></kunde>";            
   }    
}
// Ausgabe CSV
class CSV extends Ausgabe {
   public function getBeschreibung(){
     return $this->kunde->nr.";".$this->kunde->vorname.";".$this->kunde->nachname."\n";       
   }    
}
// Ausgabe Text
class Text extends Ausgabe {
   public function getBeschreibung(){
     return $this->kunde->vorname." ".$this->kunde->nachname." (".$this->kunde->nr.")";       
   }    
}

// Objekte erstellen
$anton = new Kunde(1, "Anton", "Ebenhof");
$ausgaben = array(new XML($anton),
                  new CSV($anton),
                  new Text($anton),
                  new Ausgabe($anton));
// Array mit Objekten durchlaufen und Methode aufrufen
foreach ($ausgaben as $ausgabe){
 echo htmlspecialchars($ausgabe->getBeschreibung())."<br/>";
}  
?>
</body>
</html>
