<?php
// Bestellung verwaltet verschiedene Objekte,
// die am Bestellvorgang teilnehmen
class Bestellung {
   private $warenkorb;
   private $zahlungsweise;
   private $kunde;
   
   public function __construct(Kunde $kunde,
                               Warenkorb $warenkorb,
                               Zahlungsweise $zahlungsweise){
      $this->setKunde($kunde);
      $this->setWarenkorb($warenkorb);
      $this->setZahlungsweise($zahlungsweise);                   
   }
   // Getter und Setter
   public function setKunde(Kunde $kunde){
     $this->kunde = $kunde;    
   }
   public function getKunde(){
     return $this->kunde;    
   }
   public function setZahlungsweise(Zahlungsweise $zahlungsweise){
     $this->zahlungsweise = $zahlungsweise;    
   }
   public function getZahlungsweise(){
     return $this->zahlungsweise;    
   }
   public function setWarenkorb(Warenkorb $warenkorb){
     $this->warenkorb = $warenkorb;    
   }
   public function getWarenkorb(){
     return $this->warenkorb;    
   }
   // Geschftsmethoden
   public function ausfuehren(){
     $preis = $this->warenkorb->getGesamtpreis();
     $this->zahlungsweise->setSumme($preis);
     return "Bestellung erfolgt fr Gesamtsumme "
            .$preis
            ." &euro;. Zahlung beginnen. "
            .$this->zahlungsweise->zahlen()
            .$this->warenkorb->getUebersicht();    
   }    
}
?>