<?php
// Abstrakte Klasse fr Konzept der Zahlungsweise
abstract class Zahlungsweise {
  // Konkrete Eigenschaften
  protected $empfaenger;
  protected $summe;
  // Konkreter Konstruktor
  public function __construct($empfaenger, $summe = 0){
    $this->setSumme($summe);
    $this->setEmpfaenger($empfaenger);
  }
  // Konkrete Getter- und Setter
  public function getEmpfaenger(){
    return $this->empfaenger;   
  }
  public function setEmpfaenger($empfaenger){
    $this->empfaenger = $empfaenger;   
  }
  public function getSumme(){
    return $this->summe;   
  }
  public function setSumme($summe){
    $this->summe = $summe;   
  }
  // Abstrakte Geschftsmethode
  abstract public function zahlen(); 
}

// Konkrete Klassen erben abstrakte
// und implementieren abstrakte Methoden
class Kreditkarte extends Zahlungsweise {
  // Konkrete Geschtsmethode
  public function zahlen(){
    return "Das Produkt wird mit Kreditkarte an \""
           .$this->getEmpfaenger()
           ."\" bezahlt. Summe: "
           .$this->getSumme()
           ." &euro;. ";    
  }   
}
class Bankeinzug extends Zahlungsweise {
  // Konkrete Geschtsmethode
  public function zahlen(){
    return "Das Produkt wird mit Bankeinzug an \""
           .$this->getEmpfaenger()
           ."\" bezahlt. Summe: "
           .$this->getSumme()
           ." &euro;. ";    
  }     
}
?>