<?php
// Abstrakte Klasse fr Dienstleistungen
abstract class Dienstleistung implements Kaufbar {
  // Konkrete Eigenschaften
  protected $nr;
  protected $name;
  protected $nettoPreis;
  protected $steuerSatz;
  // Konkreter Konstruktor
  public function __construct($nr, $name, $nettoPreis, $steuerSatz){
    $this->setNr($nr);
    $this->setName($name);
    if (is_double($nettoPreis)){
      $this->setNettoPreis($nettoPreis);
    }
    if (is_double($steuerSatz) && $steuerSatz <= 1){
      $this->setSteuerSatz($steuerSatz);
    }                        
  }
  //Konkrete Getter und Setter
  public function getNr(){
    return $this->nr;
  }
  public function setNr($nr){
    $this->nr = $nr;
  } 
  public function getName(){
    return $this->name;
  }
  public function setName($name){
    $this->name = $name;
  }
  public function getNettoPreis(){
    return $this->nettoPreis;
  }
  public function setNettoPreis($nettoPreis){
    $this->nettoPreis = $nettoPreis;
  }
  public function getSteuerSatz(){
    return $this->steuerSatz;
  }
  public function setSteuerSatz($steuerSatz){
    $this->steuerSatz = $steuerSatz;
  }
  public function getBruttoPreis(){
    return round($this->getNettoPreis() * (1+$this->getSteuerSatz()),2); ;
  }
  // Zahlungsweise verwalten
  public function setZahlungsweise(Zahlungsweise $zahlungsweise){
    $this->zahlungsweise = $zahlungsweise;
  }
  public function getZahlungsweise(){
    return $this->zahlungsweise;
  }
  // Abstrakte Methode
  //abstract public function getBeschreibung();              
}

// Konkrete Klassen
class Seminar extends Dienstleistung {
   private $themen;
   private $dauer;
   public function __construct($nr, $name, $nettoPreis, $steuerSatz,
                               $dauer, $themen){
     parent::__construct($nr, $name, $nettoPreis, $steuerSatz);
     $this->setThemen($themen);
     $this->setDauer($dauer);  
   }
   public function setThemen($themen){
     $this->themen = $themen;    
   }
   public function getThemen(){
     return $this->themen;    
   }
   public function setDauer($dauer){
     $this->dauer = $dauer;    
   }
   public function getDauer(){
     return $this->dauer;    
   }   
     
}
?>