<?php
// Warenkorb
class Warenkorb {
  // Array fr Kaufbares und Mengen
  private $kaufbares;
  // Konstruktor
  public function __construct(){
    $kaufbares = array();
  }
  // Kaufbares-Klon zurckliefern
  public function getKaufbares($nr){
    return clone($this->kaufbares[$nr]["kaufbar"]);
  }
  // Kaufbares in Warenkorb aufnehmen, ndern oder lschen
  public function setKaufbares(Kaufbar $kaufbar, $menge){
    $test = $this->getKaufbares($kaufbar->getNr());
    // Kaufen
    if (empty($test)){
      $this->kaufbares[$kaufbar->getNr()]
        = array("kaufbar" => $kaufbar,
                "menge"   => $menge);
    }
    // Lschen
    elseif ($menge == 0){
      unset($this->kaufbares[$kaufbar->getNr()]);
    }
    // ndern
    else {
      $this->kaufbares[$kaufbar->getNr()]["menge"] = $menge;
    }        
  }
  // Gesamtpreis fr kaufbares errechnen
  public function getGesamtpreis(){
    $preis = 0;
    foreach ($this->kaufbares as $posten){
      $preis += $posten["kaufbar"]->getBruttoPreis()
                * $posten["menge"]; 
    }
    return $preis;
  }
  // Einfache bersicht fr Kontrollen
  public function getUebersicht(){
   echo "<pre>";
   print_r($this);
   echo "</pre>";   
  }    
}

?>