<?php
// Ausname LeererWarenkorbException
class LeererWarenkorbException extends Exception {
   public function getHilfeText(){
       return "Whlen Sie erst Produkte aus.";
   }
}

// Ausnahme ZuvieleProdukteException
class ZuvieleProdukteException extends Exception {
  public function __construct($message = "Zu viele Produkte", $code = 1224){
  	 $this->message = $message;
  	 $this->code = $code;
  }
}

// ProduktMenge
class WKProdukt {
   private $menge;
   private $produkt;

   public function __construct(Produkt $produkt, $menge){
      $this->setMenge($menge);
      $this->setProdukt($produkt);
   }

   public function setMenge($menge){
    if (is_integer($menge) && $menge >= 0){
      $this->menge = $menge;
    }
   }
   public function getMenge(){
     return $this->menge;
   }
   public function setProdukt(Produkt $produkt){
     $this->produkt = $produkt;
   }
   public function getProdukt(){
      return $this->produkt;
   }
}
// Warenkorb
class Warenkorb {
  // Array fr Produkte und Mengen
  private $produkte;
  // Konstruktor
  public function __construct(){
    $this->produkte = array();
  }
  // Produkt-Klon zurckliefern
  public function getProdukt($nr){
    return $this->produkte[$nr];
  }
  // Produkt in Warenkorb aufnehmen, ndern oder lschen
  public function setProdukt(WKProdukt $produkt){
    $test = $this->getProdukt($produkt->getProdukt()->getNr());
    // Kaufen
    if (empty($test)){
      $this->produkte[$produkt->getProdukt()->getNr()] = $produkt;
    }
    // Lschen
    elseif ($produkt->getMenge() == 0){
      unset($this->produkte[$produkt->getProdukt()->getNr()]);
    }
    // ndern
    else {
      $this->produkte[$produkt->getProdukt()->getNr()] = $produkt;
    }
  }
  // Gesamtpreis fr Produkte (CD oder Buch) errechnen
  public function getGesamtpreis(){
    // Standard-Ausnahme werfen
    // Wenn kein Produkt vorhanden ist, kann kein sinnvoller Preis
    // berechnet werden.
    if (count($this->produkte) == 0){
      throw new Exception("Kein Produkt im Warenkorb.", 1222);
    }
	if (count($this->produkte) > 10){
	  throw new ZuvieleProdukteException();
	}
    $preis = 0;
    foreach ($this->produkte as $posten){
      $preis += $posten->getProdukt()->getBruttoPreis()
                * $posten->getMenge();
    }
    return $preis;
  }
  // Einfache bersicht fr Kontrollen
  public function getUebersicht(){
    // Eigene Ausnahme werfen
    // Wenn kein Produkt vorhanden ist, kann keine sinnvolle
    // Ausgabe gemacht werden.
    if (count($this->produkte) == 0){
      throw new LeererWarenkorbException("Kein Produkt im Warenkorb.", 1223);
    }
   $uebersicht = "bersicht Warenkorb: ";
   foreach ($this->produkte as $posten){
      $uebersicht .= "\""
                     .$posten->getProdukt()->getName()
                     ."\" (Menge "
                     .$posten->getMenge()
                     ."), "
                     .$posten->getProdukt()->getBruttopreis()
                     ." &euro; ";
    }
   return $uebersicht;
  }
}
?>