<?php
//////////////////////////////////////////////
// Untersuchung von Klassen
//////////////////////////////////////////////

class classInspektor {	

  // Informationen ber Klassen abrufen
  public function getKlassen(){
    // Deklarierte Klassen abrufen
    $klassen = get_declared_classes();
    // Ausgabe vorbereiten
    $text = array();
    if (!empty($klassen)){
      $i = 0;
      foreach ($klassen as $klasse){
        // Jede Klasse analysieren
        $text[$i]["Klasse"] = $klasse;
        // Methoden abrufen
        $methoden = get_class_methods($text[$i]["Klasse"]);
        if (!empty($methoden)){
          $text[$i]["Methoden"] = $methoden;
        }
        // Eigenschaften abrufen
        $eigenschaften = get_class_vars($text[$i]["Klasse"]);
        if (!empty($eigenschaften)){
            $text[$i]["Eigenschaften"] = $eigenschaften;
        }
        $i++;
      }
      // Ausgabe zurckliefern
      return $text;
    }
  }

  // Klassenmethoden abrufen
  private function getMethoden($klasse){
    // Ausgabe vorbereiten
    $methoden = array();
    if (is_string($klasse)){
      // Methoden abrufen
      $methoden = get_class_methods($klasse);
    }
    return $methoden;
  }
  
  // Klasseneigenschaften abrufen
  private function getEigenschaften($klasse){
    // Ausgabe vorbereiten
    $eigenschaften = array();
    if (is_string($klasse)){
      // Methoden abrufen
      $eigenschaften = get_class_vars($klasse);
    }
    return $eigenschaften;
  }
  
  // Objektinformationen abrufen
  public function getObjekt($objekt){
    // Ausgabe vorbereiten
    $text = array();
    // berprfung
    if (is_object($objekt)){
      // Klasse abrufen
      $klasse = get_class($objekt);
      $text["Klasse"]["Name"] = $klasse;
      // Klassenmethoden abrufen
      $methoden = array();
      $methoden = $this->getMethoden($klasse);
      if (!empty($methoden)){
        $text["Klasse"]["Methoden"] = $methoden;
      }
      // Klasseneigenschaften abrufen
      $eigenschaften = array();
      $eigenschaften = $this->getEigenschaften($klasse);
      if (!empty($eigenschaften)){
        $text["Klasse"]["Eigenschaften"] = $eigenschaften;
      }      
      // Elternklasse abrufen
      $elternKlasse = get_parent_class($objekt);
      if (!empty($elternKlasse)){
        $text["Elternklasse"]["Name"] = $elternKlasse;
        // Elternklassenmethoden abrufen
        $methoden = array();
        $methoden =$this->getMethoden($elternKlasse);
        if (!empty($methoden)){
          $text["Elternklasse"]["Methoden"] = $methoden;
        }
        // Elternklasseneigenschaften abrufen
        $eigenschaften = array();
        $eigenschaften =$this->getEigenschaften($elternKlasse);
        if (!empty($eigenschaften)){
          $text["Elternklasse"]["Eigenschaften"] = $eigenschaften;
        }
      }     
      // Objekteigenschaften und Werte abrufen
      $eigenschaften = get_object_vars($objekt);
      if (!empty($eigenschaften)){
        $text["Eigenschaften"] = $eigenschaften;
      }
    }
    return $text;
  }

 public function getSchnittstellen(){
   // Ausgabe vorbereiten
   $text = array();
   // Schnittstellen abrufen
   $schnittstellen = get_declared_interfaces();
   if (!empty($schnittstellen)){
     $i = 0;
     foreach ($schnittstellen as $schnittstelle){
       // Analyze each interface
       $text[$i]["Schnittstelle"] = $schnittstelle;
       // Methoden abrufen
       $methoden = get_class_methods($text[$i]["Schnittstelle"]);
       if (!empty($methoden)){
         $text[$i]["Methoden"] = $methoden;
       }
       $i++;
     }
   }
   return $text;
 }
 
 // Konstanten fr Funktionsauswahl
 const FKT_ALL  = 1;
 const FKT_INT  = 2;
 const FKT_UDF = 3;  
 // Funktionen abrufen
 public function getFunktionen($typ = classInspektor::FKT_ALL){
   if (isset($typ)){
     // Alle Funktionen abrufen
     $funktionen = get_defined_functions();
     if (!empty($funktionen)){
       // Bentigte Funktionen auswhlen
       switch ($typ){
         // Nur interne Funktionen
         case classInspektor::FKT_INT :
           return $funktionen["internal"];
         break;
         // Nur benutzerdefinierte Funktionen
         case classInspektor::FKT_UDF :
           return $funktionen["user"];
         break;
         // Alle Funktionen
         default:
           return $funktionen;
       }
     }
   }
 }
}
?>
