<!doctype html public "-//W3C//DTD HTML 4.0 //EN">
<html>
<head>
       <title>Fabrik-Methode</title>
</head>
<body>
<?php
// Hersteller-Klassen
// Abstrakter Hersteller
abstract class Rechnungsstellung {
  abstract function erstellen($bestellung);	
}
// Konkreter Hersteller
class StandardRechnungFabrik extends Rechnungsstellung {
  public function erstellen($bestellung){
  	if ($bestellung == 1) return new Privat();
  	if ($bestellung == 2) return new Gutschrift();
  }
}

class KomplexeRechnungFabrik extends Rechnungsstellung {
  public function erstellen($bestellung){
  	if ($bestellung == 1) return new Firma();
  }
}

// Produkt-Klassen
// Abstraktes Produkt
abstract class Rechnung {
  protected $adressen;
  protected $summe;
  public function __construct(){
    $this->adressen = array();
    $this->summe = "Summe > 0 aus DB";		
  }
  public function getAdresse(){
    return $this->adressen;
  }
  public function getSumme(){
    return $this->summe;
  }  	
}
// Konkrete Produkte
class Privat extends Rechnung {
  public function __construct(){
    parent::__construct();
	$this->adressen[] = "Einzige aus DB";	
  }		
}

class Firma extends Rechnung {
  public function __construct(){
    parent::__construct();
	$this->adressen[] = "Lieferadresse aus DB";
	$this->adressen[] = "Rechnungsadresse aus DB";	
  }	
}

class Gutschrift extends Rechnung {
  public function __construct(){
    parent::__construct();
	$this->adressen[] = "Rechnungsadresse aus DB";
	$this->summe .= " reduziert um gleichen Betrag.";		
  }		
}

// Klient
$rechnungsFabrik = new StandardRechnungFabrik();
$rechnung = $rechnungsFabrik->erstellen(2);
print_r($rechnung);
?>
</body>
</html>
