<!doctype html public "-//W3C//DTD HTML 4.0 //EN">
<html>
<head>
       <title>Dekorierer</title>
</head>
<body>
<?php
// Abstrakte Komponente
abstract class Angebot {
  // Zu dekorierende Methode    
  abstract public function getPreis(); 
}

// Konkrete Komponente
class Produkt extends Angebot {
  public $name;
  public $preis;
  
  public function __construct($name, $preis){
    $this->name = $name;
    $this->preis = $preis;    
  }
  // Zu dekorierende Methode
  public function getPreis(){
    return $this->preis * 1.19;    
  }   
}

// Abstrakter Dekorierer
abstract class ProduktDekorierer extends Angebot {
  // Gespeichertes Objekt zur Dekoration  
  protected $angebot;
  // Konstruktor mit bernahme des
  // zu dekorierenden Objekts 
  public function __construct(Angebot $angebot){
     $this->angebot = $angebot;  
  }    
}

// Konkrete Dekorierer
class FuenfEuroGutschein extends ProduktDekorierer {  
  public function getPreis(){
    return $this->angebot->getPreis() - 5;    
  }  
}
class GuterKundeGutschein extends ProduktDekorierer {
  public function getPreis(){
    return $this->angebot->getPreis() * 0.95;    
  }  
}

// Klient
$produkt = new FuenfEuroGutschein(
            new GuterKundeGutschein(
             new Produkt("PHP und OOP", 32.99)));

echo round($produkt->getPreis(),2);             
?>
</body>
</html>
