<!doctype html public "-//W3C//DTD HTML 4.0 //EN">
<html>
<head>
       <title>Kompositum</title>
</head>
<body>
<?php
// Obertyp von Teil und Ganzem
abstract class Bestellung {
  protected $nr;
  public function __construct($nr){
    $this->nr = $nr;    
  }
  // Geschftsmethode  
  abstract function getGesamtpreis();
  // Zugriff
  public function getNr(){
    return $this->nr;    
  }  
}
// Teil (Blatt)
class Teilbestellung extends Bestellung {
  private $warenwert;
  // berschriebener Konstruktor
  public function __construct($nr, $warenwert){
    parent::__construct($nr);
    $this->warenwert = $warenwert;    
  }
  // Konkrete Geschftsmethode    
  function getGesamtpreis(){
    return $this->warenwert;  
  }   
}
// Ganzes
class Kombibestellung  extends Bestellung{
  // Teile
  private $bestellungen;
  // Konstruktor
  public function __construct($nr){
    parent::__construct($nr);
    $this->bestellungen = array();   
  }
  // Verwaltungsmethoden
  public function addBestellung(Bestellung $bestellung){
    $this->bestellungen[$bestellung->getNr()] = $bestellung;  
  }
  public function removeBestellung(Bestellung $bestellung){
    unset($this->bestellungen[$bestellung->getNr()]);   
  }
  
  // Geschftsmethode
  public function getGesamtpreis(){
    $preis = 0;
    foreach ($this->bestellungen as $bestellung){
       $preis += $bestellung->getGesamtpreis();  
    }
    return $preis;  
  }   
}

// Klient
$teil1 = new Teilbestellung(1, 25);
$teil2 = new Teilbestellung(2, 15);
$teil3 = new Teilbestellung(3, 30);
$kombi = new KombiBestellung(1);
$kombi->addBestellung($teil1);
$kombi->addBestellung($teil2);
$kombi->addBestellung($teil3);
echo $kombi->getGesamtpreis()."<br/>";
$kombi->removeBestellung($teil3);
echo $kombi->getGesamtpreis()."<br/>";
?>
</body>
</html>
