<!doctype html public "-//W3C//DTD HTML 4.0 //EN">
<html>
<head>
       <title>Besucher</title>
</head>
<body>
<?php
// Besucher
interface Besucher {
  public function besuchen(Bestellung $bestellung);
}

interface Besuchbar {
    public function aufnehmen(Besucher $besucher);
}

class Portoberechnung implements Besucher {
   public function besuchen(Bestellung $bestellung){
     if ($bestellung instanceof Teilbestellung){
       $bestellung->setPorto($bestellung->getGesamtpreis()*0.05);    
     }   
   }    
}

// Kompositum
abstract class Bestellung implements Besuchbar {
  protected $nr;
  protected $porto;
  public function __construct($nr){
    $this->nr = $nr;    
  }
  // Geschftsmethode  
  abstract function getGesamtpreis();
  // Zugriff
  public function getNr(){
    return $this->nr;    
  }
  public function setPorto($porto){
    $this->porto = $porto;   
  }
  public function getPorto(){
    return $this->porto;   
  }
  // Implementierte Methode
  public function aufnehmen(Besucher $besucher){
    $besucher->besuchen($this);    
  }  
}

class Teilbestellung extends Bestellung {
  private $warenwert;
  // berschriebener Konstruktor
  public function __construct($nr, $warenwert){
    parent::__construct($nr);
    $this->warenwert = $warenwert;    
  }
  // Konkrete Geschftsmethode    
  function getGesamtpreis(){
    return $this->warenwert + $this->getPorto();  
  }   
}

class Kombibestellung  extends Bestellung{
  // Teile
  private $bestellungen;
  // Konstruktor
  public function __construct($nr){
    parent::__construct($nr);
    $this->bestellungen = array();   
  }
  // Verwaltungsmethoden
  public function addBestellung(Bestellung $bestellung){
    $this->bestellungen[$bestellung->getNr()] = $bestellung;  
  }
  public function removeBestellung(Bestellung $bestellung){
    unset($this->bestellungen[$bestellung->getNr()]);   
  }
  
  // Geschftsmethode
  public function getGesamtpreis(){
    $preis = 0;
    foreach ($this->bestellungen as $bestellung){
       $preis += $bestellung->getGesamtpreis();  
    }
    return $preis;  
  }   
}


// Klient
$teil1 = new Teilbestellung(1, 10);
$teil1->aufnehmen(new Portoberechnung());
$teil2 = new Teilbestellung(2, 5);
$teil2->aufnehmen(new Portoberechnung());
$kombi = new KombiBestellung(1);
$kombi->addBestellung($teil1);
$kombi->addBestellung($teil2);
echo $kombi->getGesamtpreis()."<br/>";
?>
</body>
</html>
