<!doctype html public "-//W3C//DTD HTML 4.0 //EN">
<html>
<head>
       <title>Schablonenmethode</title>
</head>
<body>
<?php
abstract class Bestellung {
  protected $zusammenfassung;
  // Konstruktor
  public function __construct(){
    $this->zusammenfassung = "";   
  }
  // Konkrete primitive Operation  
  protected function kundeErfassen(){
     $this->zusammenfassung .= "Kunde in DB speichern. ";   
  }
  protected function bestellungErfassen(){
     $this->zusammenfassung .= "Bestellung in DB speichern. ";   
  }  
  // Abstrakte primitive Operation
  protected abstract function preisBerechnen();
  // Haken und abhngige Methode
  protected function istAngebot(){
    return false;   
  }
  protected function preisReduzieren(){}
  // Schablonenmethode
  public function durchfuehren(){
    $this->kundeErfassen();
    $this->preisBerechnen();
    // Haken nutzen
    if ($this->istAngebot()){
      $this->preisReduzieren();   
    }
    $this->bestellungErfassen();     
    return $this->zusammenfassung;
  }  
}

// Konkrete Bestellvorgnge
class Sonderangebot extends Bestellung {
  // Abstrakte Methoden programmieren
  protected function preisBerechnen(){
    $this->zusammenfassung .= "Preis fr Sonderangebot ermitteln. ";   
  }
  // Haken und abhngige Methode
  protected function istAngebot(){
    return true;   
  }
  protected function preisReduzieren(){
    $this->zusammenfassung .= "Preis reduzieren. ";   
  }
}

class Standard extends Bestellung {
  // Abstrakte Methoden programmieren
  protected function preisBerechnen(){
    $this->zusammenfassung .= "Preis fr Standard ermitteln. ";   
  }
}

// Klient
$standard = new Standard();
echo $standard->durchfuehren()."<br/>";

$angebot = new Sonderangebot();
echo $angebot->durchfuehren();
?>
</body>
</html>

