<?php
// Geschftslogikschicht
class Controller {
  public static function run(){
    if (!isset($_GET["aktion"])){
      return new Index();
    }  
    else {
      $klasse = "Produkt".$_GET["aktion"];
      if (class_exists($klasse)){
        return new $klasse();  
      }                   
    }    	
  }	
}
// Abstrakter Befehl
abstract class Befehl {
  abstract public function ausfuehren();	
}
// Standard-Befehl fr Index-Seite
class Index extends Befehl {
  public function ausfuehren(){
   $produkte = ProduktGateway::findAll();
   echo HtmlAusgabe::getUebersichtAlle($produkte, "Details", "Mehr");
   echo "<hr/>";
   echo HtmlAusgabe::getUebersichtAlle($produkte, "Bearbeiten", "Bearbeiten");
   echo "<hr/>";
   echo "<a href=\"index.php?aktion=Erfassen\">Produkt erfassen</a>";    	
  }	
}
// Produkt erfassen und Erfassung besttigen
class ProduktErfassen extends Befehl {
  public function ausfuehren(){
  	if (empty($_REQUEST["name"]) || empty($_REQUEST["preis"])){
     echo HtmlAusgabe::getEinfuegenFormular("index.php", "Erfassen");
	}
	else {
	 ProduktGateway::insert(new Produkt($_REQUEST["name"], $_REQUEST["preis"]));
     echo HtmlAusgabe::getDetails(ProduktGateway::findByName($_REQUEST["name"]));
     echo "<a href=\"index.php\">Index</a>";	 	
	}	
  }	
}
// Produkt bearbeiten und Bearbeitung besttigen
class ProduktBearbeiten extends Befehl {
  public function ausfuehren(){
  	if (empty($_REQUEST["nameAlt"]) || 
	    empty($_REQUEST["name"]) || empty($_REQUEST["preis"])){
     echo HtmlAusgabe::getBearbeitenFormular("index.php",
	                                        "Bearbeiten",
								            ProduktGateway::findByName($_REQUEST["produkt"]));
	}
	else {
	 ProduktGateway::update($_REQUEST["nameAlt"], new Produkt($_REQUEST["name"], $_REQUEST["preis"]));
     echo HtmlAusgabe::getDetails(ProduktGateway::findByName($_REQUEST["name"]));
     echo "<a href=\"index.php\">Index</a>";	  	
	}	
  }	 
}
// Produktdetails anzeigen
class ProduktDetails extends Befehl {
  public function ausfuehren(){
    echo HtmlAusgabe::getDetails(ProduktGateway::findByName($_REQUEST["produkt"]));	
  }	
}
?>