<?php
// Geschftslogikschicht
class Controller {
  public static function run(){
    if (!isset($_GET["aktion"])){
      return new Index();
    }  
    else {
      $klasse = "Produkt".$_GET["aktion"];
      if (class_exists($klasse)){
        return new $klasse();  
      }                   
    }    	
  }	
}
// Abstrakter Befehl
abstract class Befehl {
  protected $klient;	
  abstract public function ausfuehren();
  public function __construct(){
    $this->klient = new SoapClient(null,
                           array("location" => "http://localhost/oop/Uebungen/6_Mehrschichtigkeit/4/ProduktServer.php",
	       				        "soap_version" => "SOAP_1_2",
						        "encoding" => "ISO-8859-1",
							    "uri" => "http://webshop.biz/",
								"trace" => 1));																	
  }	
}
// Standard-Befehl fr Index-Seite
class Index extends Befehl {
  public function ausfuehren(){
   $produkte = $this->klient->findAll();
   //echo $this->klient->__getLastRequest();
   //echo $this->klient->__getLastResponse();								     
   echo HtmlAusgabe::getUebersichtAlle($produkte, "Details", "Mehr");
   echo "<hr/>";
   echo HtmlAusgabe::getUebersichtAlle($produkte, "Bearbeiten", "Bearbeiten");
   echo "<hr/>";
   echo "<a href=\"index.php?aktion=Erfassen\">Produkt erfassen</a>";    	
  }	
}
// Produkt erfassen und Erfassung besttigen
class ProduktErfassen extends Befehl {
  public function ausfuehren(){
  	if (empty($_REQUEST["name"]) || empty($_REQUEST["preis"])){
     echo HtmlAusgabe::getEinfuegenFormular("index.php", "Erfassen");
	}
	else {
	 $produkt = new Produkt($_REQUEST["name"], $_REQUEST["preis"]);
     $this->klient->insert($produkt);
     echo HtmlAusgabe::getDetails($this->klient->findByName($_REQUEST["name"]));
     echo "<a href=\"index.php\">Index</a>";	 	
	}	
  }	
}
// Produkt bearbeiten und Bearbeitung besttigen
class ProduktBearbeiten extends Befehl {
  public function ausfuehren(){
  	if (empty($_REQUEST["nameAlt"]) || 
	    empty($_REQUEST["name"]) || empty($_REQUEST["preis"])){
     echo HtmlAusgabe::getBearbeitenFormular("index.php",
	                                        "Bearbeiten",
								            $this->klient->findByName($_REQUEST["produkt"]));
	}
	else {
	 $this->klient->update($_REQUEST["nameAlt"], new Produkt($_REQUEST["name"], $_REQUEST["preis"]));
     echo HtmlAusgabe::getDetails($this->klient->findByName($_REQUEST["name"]));
     echo "<a href=\"index.php\">Index</a>";	  	
	}	
  }	 
}
// Produktdetails anzeigen
class ProduktDetails extends Befehl {
  public function ausfuehren(){  	
   echo HtmlAusgabe::getDetails($this->klient->findByName($_REQUEST["produkt"]));
   //echo $this->klient->__getLastRequest();
   //echo $this->klient->__getLastResponse();		
  }	
}
?>